function []=hist_demo()
% Demonstration of histogram, contrast stretching and histogram
% equalization.

in_img=imread('clock.jpg');

% Histogram & contrast stretching
in_img_dbl=double(in_img);
m=min(in_img_dbl(:));
M=max(in_img_dbl(:));
img_stretched_contrast_dbl=255*(in_img_dbl-m)/(M-m); % In order to perform 
                                                  % the division correctly, 
                                                  % we had to convert the 
                                                  % image from uint8 to 
                                                  % double.
img_stretched_contrast=uint8(img_stretched_contrast_dbl); % In order to
                                                  % display the image
                                                  % correctly, we had to 
                                                  % convert the image back 
                                                  % to uint8.

figure;
subplot(2,2,1);
imshow(in_img);
title('The image of clock');
subplot(2,2,2);
imhist(in_img)
grid on;
title('The histogram of clock image');
subplot(2,2,3);
imshow(img_stretched_contrast);
title('The image after contrast stretching');
subplot(2,2,4);
imhist(img_stretched_contrast);
grid on;
title('The histogram of image after contrast stretching');

% Histogram equalization
img_hist_eq=histeq(in_img);

figure;
subplot(2,2,1);
imshow(in_img);
title('The image of clock');
subplot(2,2,2);
imhist(in_img);
grid on;
title('The histogram of clock image');
subplot(2,2,3);
imshow(img_hist_eq);
title('The image after hist. equalization');
subplot(2,2,4);
imhist(img_hist_eq);
grid on;
title('The histogram of image after hist. equalization');