function [im_res, im]= resize_im(im, N, method)
% Resizing of image (shrinking and expanding).
%
% Input arguments: 
%   im - image, 
%   N - resizing factor, 
%   method - interpolation method ('nearest', 'bilinear' or 'bicubic').
% Output arguments:
%   im_res - image after shrinking and expanding by the same resizing
%            factor,
%   im - original image (cropped to im_res size, if necessary).

im_shrink = imresize(im, 1/N, method);
im_res = imresize(im_shrink, N, method);

M = min(size(im,1), size(im_res,1));
N = min(size(im,2), size(im_res,2));
im_res = im_res(round(size(im_res,1)/2)-round(M/2)+1:...
                round(size(im_res,1)/2)+round(M/2),...
                round(size(im_res,2)/2)-round(N/2)+1:...
                round(size(im_res,2)/2)+round(N/2));
im = im(round(size(im,1)/2)-round(M/2)+1:round(size(im,1)/2)+round(M/2),...
        round(size(im,2)/2)-round(N/2)+1:round(size(im,2)/2)+round(N/2));